SoExtSelection(3)

NAME
SoExtSelection - The SoExtSelection class can be used for extended selection functionality.

SYNOPSIS

#include <Inventor/nodes/SoExtSelection.h>

Inherits SoSelection.

  Public Types
enum LassoType { NOLASSO, LASSO, RECTANGLE }
enum LassoPolicy { FULL_BBOX, PART_BBOX, FULL, PART }
enum LassoMode { ALL_SHAPES, VISIBLE_SHAPES }

  Public Member Functions
virtual SoType getTypeId (void) const
SoExtSelection (void)
void useOverlay (SbBool overlay=TRUE)
SbBool isUsingOverlay (void)
SoSeparator * getOverlaySceneGraph (void)
void setOverlayLassoColorIndex (const int index)
int getOverlayLassoColorIndex (void)
void setLassoColor (const SbColor &color)
const SbColor & getLassoColor (void)
void setLassoWidth (const float width)
float getLassoWidth (void)
void setOverlayLassoPattern (const unsigned short pattern)
unsigned short getOverlayLassoPattern (void)
void animateOverlayLasso (const SbBool animate=TRUE)
SbBool isOverlayLassoAnimated (void)
virtual void handleEvent (SoHandleEventAction *action)
virtual void GLRenderBelowPath (SoGLRenderAction *action)
void select (SoNode *root, int numcoords, SbVec2f *lasso, const SbViewportRegion &vp, SbBool shiftpolicy)
void select (SoNode *root, int numcoords, SbVec3f *lasso, const SbViewportRegion &vp, SbBool shiftkeypolicy)
const SbVec2s * getLassoCoordsDC (int &numCoords)
const SbVec3f * getLassoCoordsWC (int &numCoords)
const SoPathList & getSelectionPathList () const
void setLassoFilterCallback (SoLassoSelectionFilterCB *f, void *userdata=NULL, const SbBool callonlyifselectable=TRUE)
void setTriangleFilterCallback (SoExtSelectionTriangleCB *func, void *userdata=NULL)
void setLineSegmentFilterCallback (SoExtSelectionLineSegmentCB *func, void *userdata=NULL)
void setPointFilterCallback (SoExtSelectionPointCB *func, void *userdata=NULL)
SbBool wasShiftDown (void) const

  Static Public Member Functions
static SoType getClassTypeId (void)
static void initClass (void)
Sets up initialization for data common to all instances of this class, like submitting necessary information to the Coin type system.

  Public Attributes
SoSFEnum lassoType
SoSFEnum lassoPolicy
SoSFEnum lassoMode

  Protected Member Functions
virtual const SoFieldData * getFieldData (void) const
virtual ~SoExtSelection ()

  Static Protected Member Functions
static const SoFieldData ** getFieldDataPtr (void)

  Additional Inherited Members

Detailed Description

The SoExtSelection class can be used for extended selection functionality. This class enables you to select geometry by specifying a lasso (a polygon) or a rectangle on screen. When objects are selected, you'll receive the same callbacks as for the SoSelection node.

The application programmer interface of this class is somewhat complex, due to its non-trivial functionality. To see an extensive usage example of the SoExtSelection node, we advise you to go look at the 'extselection' example application in the 'nodes/' directory of the SoGuiExamples Mercurial repository. Further information and links for downloading and building this module should be available at github.com/coin3d/soguiexamples.

This node class is an extension versus the original SGI Inventor v2.1 API. It is based on the API of VSG (was TGS) Inventor's SoExtSelection, and we aim to be fully compatible with this node to enable users to switch between using Coin and VSG Inventor. Please contact us if you find discrepancies between Coin's SoExtSelection and VSG's SoExtSelection node.

FILE FORMAT/DEFAULTS:

ExtSelection {
    renderCaching AUTO
    boundingBoxCaching AUTO
    renderCulling AUTO
    pickCulling AUTO
    policy SHIFT
    lassoType NOLASSO
    lassoPolicy FULL_BBOX
    lassoMode ALL_SHAPES
}

Since
    TGS Inventor 2.5

    Coin 1.0

Member Enumeration Documentation

  enum SoExtSelection::LassoType
Enum for type of lasso selection.

Enumerator

NOLASSO
    Makes this node behave like a normal SoSelection node.

LASSO
    Select objects using a lasso. Selections can be aborted by the end-user by hitting the END key on the keyboard.

RECTANGLE
    Select objects using a rectangle. Selections can be aborted by the end-user by hitting the END key on the keyboard.

  enum SoExtSelection::LassoPolicy
Enum for specifying how objects are selected.

Enumerator

FULL_BBOX
    The entire bounding box must be inside the lasso/rectangle.

PART_BBOX
    Some part of the bounding box must intersect the lasso/rectangle.

FULL
    All primitives must be completely inside the lasso/rectangle.

PART
    Some primitive must intersect the lasso/rectangle.

  enum SoExtSelection::LassoMode
Enum for specifying selection mode.

Enumerator

ALL_SHAPES
    All primitives inside the lasso/rectangle will be selected.

VISIBLE_SHAPES
    All visible primitives inside the lasso/rectangle will be selected.

Constructor & Destructor Documentation

  SoExtSelection::SoExtSelection (void)
Constructor.

  SoExtSelection::~SoExtSelection () [protected], [virtual]
Destructor.

Member Function Documentation

  SoType SoExtSelection::getClassTypeId (void) [static]
This static method returns the SoType object associated with objects of this class.

  SoType SoExtSelection::getTypeId (void) const [virtual]
Returns the type identification of an object derived from a class inheriting SoBase. This is used for runtime type checking and 'downward' casting.

Reimplemented from SoSelection.

  const SoFieldData ** SoExtSelection::getFieldDataPtr (void) [static], [protected]
This API member is considered internal to the library, as it is not likely to be of interest to the application programmer.
 Returns the SoFieldData class which holds information about fields in this node.

  const SoFieldData * SoExtSelection::getFieldData (void) const [protected], [virtual]
Returns a pointer to the class-wide field data storage object for this instance. If no fields are present, returns NULL.

Reimplemented from SoSelection.

  void SoExtSelection::useOverlay (SbBool overlay = TRUE)
Specifies whether the overlay planes should be used to render the lasso.

This method has been obsoleted in Coin, as most graphics cards comes without support for overlay rendering. A better strategy is to just 'overlay' the lasso graphics on top of the scene after everything else has been rendered -- and this is the strategy we apply in Coin.

  SbBool SoExtSelection::isUsingOverlay (void)
Returns whether overlay planes are used to draw the lasso.

See also
    useOverlay().

  SoSeparator * SoExtSelection::getOverlaySceneGraph (void)
Returns the scene graph for overlay rendering. Will always return NULL in Coin, as this method has been obsoleted.

(It is probably used in TGS Inventor from the SoXt / SoWin libraries' So[Xt|Win]RenderArea class to fetch the overlay graph to draw, and as such should be treated as an internal method.)

  void SoExtSelection::setOverlayLassoColorIndex (const int index)
Obsoleted in Coin, use SoExtSelection::setLassoColor() instead.

  int SoExtSelection::getOverlayLassoColorIndex (void)
Obsoleted in Coin, use SoExtSelection::getLassoColor() instead.

See also
    setOverlayLassoColorIndex().

  void SoExtSelection::setLassoColor (const SbColor & color)
Sets the lasso/rectangle line color. Default value is (1.0, 1.0, 1.0).

  const SbColor & SoExtSelection::getLassoColor (void)
Returns the lasso color.

  void SoExtSelection::setLassoWidth (const float width)
Sets the lasso line width. Default value is 1.0.

  float SoExtSelection::getLassoWidth (void)
Returns the lasso line width.

  void SoExtSelection::setOverlayLassoPattern (const unsigned short pattern)
Sets the lasso line pattern. Default value is 0xf0f0.

  unsigned short SoExtSelection::getOverlayLassoPattern (void)
Returns the lasso line pattern.

  void SoExtSelection::animateOverlayLasso (const SbBool animate = TRUE)
Sets whether the lasso should be animated by scrolling the line pattern.

  SbBool SoExtSelection::isOverlayLassoAnimated (void)
Returns whether the lasso is set to animate or not.

  void SoExtSelection::handleEvent (SoHandleEventAction * action) [virtual]
Action method for SoHandleEventAction.

Inspects the event data from action, and processes it if it is something which this node should react to.

Nodes influencing relevant state variables for how event handling is done also override this method.

Reimplemented from SoSelection.

  void SoExtSelection::GLRenderBelowPath (SoGLRenderAction * action) [virtual]
SGI Open Inventor v2.1 obsoleted support for SoGLRenderAction::addMethod(). Instead, GLRender() might be called directly, and to optimize traversal, the SoSeparator node calls GLRenderBelowPath whenever the path code is BELOW_PATH or NO_PATH (path code is guaranteed not to change). To be compatible with SGI's Inventor (and thereby also TGS') we have chosen to follow their implementation in this respect.

SoSeparator::GLRenderBelowPath() does not traverse its children using SoChildList::traverse(), but calls GLRenderBelowPath() directly for all its children.

Reimplemented from SoSeparator.

  void SoExtSelection::select (SoNode * root, int numcoords, SbVec2f * lasso, const SbViewportRegion & vp, SbBool shiftpolicy)
Simulate lasso selection programmatically.

This function is currently just stubbed.

  void SoExtSelection::select (SoNode * root, int numcoords, SbVec3f * lasso, const SbViewportRegion & vp, SbBool shiftpolicy)
Simulate lasso selection programmatically.

This function is currently just stubbed.

  const SbVec2s * SoExtSelection::getLassoCoordsDC (int & numCoords)
Returns lasso coordinates in device coordinates.

This function is currently just stubbed.

  const SbVec3f * SoExtSelection::getLassoCoordsWC (int & numCoords)
Returns lasso coordinates in world coordinates.

This function is currently just stubbed.

  const SoPathList & SoExtSelection::getSelectionPathList () const
Returns a path list containing selected objects.

This function is currently just stubbed.

  void SoExtSelection::setLassoFilterCallback (SoLassoSelectionFilterCB * f, void * userdata = NULL, const SbBool callonlyifselectable = TRUE)
The lasso selection filter callback is called when a node is about to be selected, and enables the application programmer to return a new path to be used when selecting. The new returned path should not be ref'd. SoExtSelection will ref() and unref() it.

To cancel the selection, return NULL from the callback.

if callonlyifselectable is TRUE, the callback will only be invoked when the path to the new node pass through the SoExtSelection node.

This method is specific to Coin, and is not part of TGS OIV.

  void SoExtSelection::setTriangleFilterCallback (SoExtSelectionTriangleCB * func, void * userdata = NULL)
Sets the callback that will be called for every triangle inside the lasso/rectangle when selecting.

The callback should return FALSE if it wants to continue being invoked. When the callback returns TRUE, the object/shape is selected, and no more callbacks will be invoked for the object.

See also
    setLineSegmentFilterCallback, setPointFilterCallback

  void SoExtSelection::setLineSegmentFilterCallback (SoExtSelectionLineSegmentCB * func, void * userdata = NULL)
Sets the callback that will be called for every line segment inside the lasso/rectangle when selecting.

The callback should return FALSE if it wants to continue being invoked. When the callback returns TRUE, the object/shape is selected, and no more callbacks will be invoked for the object.

See also
    setTriangleFilterCallback, setPointFilterCallback

  void SoExtSelection::setPointFilterCallback (SoExtSelectionPointCB * func, void * userdata = NULL)
Sets the callback that will be called for every point inside the lasso/rectangle when selecting.

The callback should return FALSE if it wants to continue being invoked. When the user returns TRUE, the object/shape is selected, and no more callbacks will be invoked for the object.

See also
    setLineSegmentFilterCallback, setTriangleFilterCallback

  SbBool SoExtSelection::wasShiftDown (void) const
Returns whether the SHIFT key was pressed during the latest user interaction. This is useful if you want to respect the shift policy while selecting primitives.

This method is specific to Coin, and is not part of TGS OIV.

Member Data Documentation

  SoSFEnum SoExtSelection::lassoType
Field for lasso type. Default value is SoExtSelection::NOLASSO.

Selections with type SoExtSelection::RECTANGLE or SoExtSelection::LASSO can be aborted by the end-user by hitting the END key on the keyboard.

  SoSFEnum SoExtSelection::lassoPolicy
Field for lasso policy. Default value is FULL_BBOX.

  SoSFEnum SoExtSelection::lassoMode
Field for lasso mode. Default value is ALL_SHAPES.

Set this field to VISIBLE_SHAPES to make only the primitives visible from the current viewpoint be selected.

Author

Generated automatically by Doxygen for Coin from the source code.